if (!window.PluginUtil) {
    var PluginUtil = {
        register: function(namespace, pluginName, rawPlugin) {
            for (var methodName in rawPlugin) {
                if (!rawPlugin.hasOwnProperty(methodName) || (typeof rawPlugin[methodName] != 'function'))
                    continue;
                window[namespace] = window[namespace] || {};
                if (!window[namespace][pluginName]) {
                    window[namespace][pluginName] = {};
                }

                var pluginProxy = window[namespace][pluginName];
                pluginProxy[methodName] = (function(methodName) {
                    return function() {
                        var args = arguments;
                        if (window.plus && window.plus.isReady) {
                            rawPlugin[methodName].apply(window, args);
                        } else {
                            document.addEventListener("plusready",  function() {
                                rawPlugin[methodName].apply(window, args);
                            }, true);
                        }
                    }
                })(methodName);
            }
        }
    };
}

(function() {
    //插件名称
    var PLUGIN_NAME = "AppPlugin";
    //定义JS插件
    var AppPlugin = {
        /**
        * 获取App框架版本
        **/
        getFrameVersion : function (successCallback, errorCallback) {
                    var success = typeof successCallback !== 'function' ? null : function(data) {
                        successCallback(data);
                    };
                    var fail = typeof errorCallback !== 'function' ? null : function(args) {
                        errorCallback(args);
                    };
                    var callbackId = window.plus.bridge.callbackId(success, fail);
                    var args = [callbackId];
                    return window.plus.bridge.exec(PLUGIN_NAME, "getFrameVersion", args);
        },
         judgeFingerprintOrFaceId : function (successCallback,errorCallback) {
                     var success = typeof successCallback !== 'function' ? null : function(data) {
                     successCallback(data);
                     };
                     var fail = typeof errorCallback !== 'function' ? null : function(args) {
                     errorCallback(args);
                     };
                     var callbackId = window.plus.bridge.callbackId(success, fail);
                     var args = [callbackId];
                     return window.plus.bridge.exec(PLUGIN_NAME, "judgeFingerprintOrFaceId", args);
         },
         safeCenterConfig : function (successCallback,errorCallback) {
            var success = typeof successCallback !== 'function' ? null : function(data) {
            successCallback(data);
            };
            var fail = typeof errorCallback !== 'function' ? null : function(args) {
            errorCallback(args);
            };
            var callbackId = window.plus.bridge.callbackId(success, fail);
            var args = [callbackId];
            return window.plus.bridge.exec(PLUGIN_NAME, "safeCenterConfig", args);
        },
        registerAppStateChange : function (callback) {
            var success = typeof callback !== 'function' ? null : function(data) {
                callback(data);
            };
            var callbackId = window.plus.bridge.callbackId(success);
            var args = [callbackId];
            return window.plus.bridge.exec(PLUGIN_NAME, "registerAppStateChange", args);
        },
        //设置状态栏样式
        setStatusBarStyle : function (type, successCallback, errorCallback) {
            var success = typeof successCallback !== 'function' ? null : function(data) {
            successCallback(data);
            };
            var fail = typeof errorCallback !== 'function' ? null : function(args) {
            errorCallback(args);
            };
            var callbackId = window.plus.bridge.callbackId(success, fail);
            var args = [callbackId, type];
            return window.plus.bridge.exec(PLUGIN_NAME, "setStatusBarStyle", args);
        },
        //获取状态栏高度
        getStatusBarHeight : function (callback) {
            var success = typeof callback !== 'function' ? null : function(data) {
                callback(data);
            };
            var callbackId = window.plus.bridge.callbackId(success);
            var args = [callbackId];
            return window.plus.bridge.exec(PLUGIN_NAME, "getStatusBarHeight", args);
        },
        isNotificationEnabled : function (callback) {
             var success = typeof callback !== 'function' ? null : function(data) {
                 callback(data);
             };
             var callbackId = window.plus.bridge.callbackId(success);
             var args = [callbackId];
             return window.plus.bridge.exec(PLUGIN_NAME, "isNotificationEnabled", args);
        },
 }

    //输出插件
    window.PluginUtil.register("muapp", PLUGIN_NAME, AppPlugin);

})();
