if (!window.PluginUtil) {
    var PluginUtil = {
        register: function(namespace, pluginName, rawPlugin) {
            for (var methodName in rawPlugin) {
                if (!rawPlugin.hasOwnProperty(methodName) || (typeof rawPlugin[methodName] != 'function'))
                    continue;

                window[namespace] = window[namespace] || {};
                if (!window[namespace][pluginName]) {
                    window[namespace][pluginName] = {};
                }

                var pluginProxy = window[namespace][pluginName];
                pluginProxy[methodName] = (function(methodName) {
                    return function() {
                        if (window.plus && window.plus.isReady) {
                            rawPlugin[methodName].apply(window, arguments);
                        } else {
                            document.addEventListener("plusready",  function() {
                                rawPlugin[methodName].apply(window, arguments);
                            }, true);
                        }
                    }
                })(methodName);
            }
        }
    };
}

(function() {
    //插件名称
    var PLUGIN_NAME = "LocalBiometricPlugin";

    //定义JS插件
    var LocalBiometricPlugin = {

          /**
          * 验证指纹
          *  scene	int	需要验签的场景
          * purpose  枚举的数字字符串： 1：开启登录指纹，  2：开启交易指纹， 3：登录， 4：订单支付， 5：借款取现， 6：开通闪付， 7：闪付交易， 8：闪付展示二维码，
          * bizcontent	object 	不同场景使用不同的签名数据，sdk签名时再按照key的字典顺进行排序后，组装成字符串再签名，
                                组装后字符串形式如：key1=v1&key2=v2&key3=v3
          */
        authenticate : function (scene,purpose, bizContent,successCallback, errorCallback) {

            var success = typeof successCallback !== 'function' ? null : function(data) {
                           successCallback(data);
                       };
            var fail = typeof errorCallback !== 'function' ? null : function(args) {
                           errorCallback(args);
                       };
            var callbackId = window.plus.bridge.callbackId(success, fail);
            var args = [callbackId,scene,purpose, bizContent];
            return window.plus.bridge.exec(PLUGIN_NAME, "authenticate", args);
        },

        /**
         * 具体场景是否开启了指纹功能
         */
       isOpen : function (scene,successCallback, errorCallback) {

                var success = typeof successCallback !== 'function' ? null : function(data) {
                               successCallback(data);
                           };
                var fail = typeof errorCallback !== 'function' ? null : function(args) {
                               errorCallback(args);
                           };
                var callbackId = window.plus.bridge.callbackId(success, fail);
                var args = [callbackId,scene];
                return window.plus.bridge.exec(PLUGIN_NAME, "isOpen", args);
        },

        /**
         * 具体场景是否能支持开启指纹
         */
         getSupport: function (successCallback, errorCallback) {
                  var success = typeof successCallback !== 'function' ? null : function(data) {
                     successCallback(data);
                  };
                  var fail = typeof errorCallback !== 'function' ? null : function(args) {
                     errorCallback(args);
                  };
                  var callbackId = window.plus.bridge.callbackId(success, fail);
                  var args = [callbackId];
                  return window.plus.bridge.exec(PLUGIN_NAME, "getSupport", args);
                 },
    };
    //输出插件
    window.PluginUtil.register("muapp", PLUGIN_NAME, LocalBiometricPlugin);

})();