if (!window.PluginUtil) {
    var PluginUtil = {
        register: function(namespace, pluginName, rawPlugin) {
            for (var methodName in rawPlugin) {
                if (!rawPlugin.hasOwnProperty(methodName) || (typeof rawPlugin[methodName] != 'function'))
                    continue;
                window[namespace] = window[namespace] || {};
                if (!window[namespace][pluginName]) {
                    window[namespace][pluginName] = {};
                }

                var pluginProxy = window[namespace][pluginName];
                pluginProxy[methodName] = (function(methodName) {
                    return function() {
                        var args = arguments;
                        if (window.plus && window.plus.isReady) {
                            rawPlugin[methodName].apply(window, args);
                        } else {
                            document.addEventListener("plusready",  function() {
                                rawPlugin[methodName].apply(window, args);
                            }, true);
                        }
                    }
                })(methodName);
            }
        }
    };
}

(function() {

   var PLUGIN_NAME = "MUMockPlugin";
   //定义JS插件
   var MUMockPlugin = {
   	   /* mock策略：
   	    * 0:不使用mock
   	    * 1.本地mock文件，云测不用考虑这个策略
   	    * 2.FTP mock文件
   	   */

   	   //获取当前mock策略
   	   getCurrentMockStrategy: function (callback) {
            var success = typeof callback !== 'function' ? null : function(data) {
                callback(data);
            };
            var callbackId = window.plus.bridge.callbackId(success);
            var args = [callbackId];
            return window.plus.bridge.exec(PLUGIN_NAME, "getCurrentMockStrategy", args);
   	   },
   	   /* 刷新mock策略
   	   	* strategy 策略
   	   	* filename 如果用FTP策略，这个参数必须要传，例如文件地址为http://mock-data.test.upcdn.net/mock/ldsapp_0627.ios，则这里filename传入'ldsapp_0627.ios'
   	   */
   	   refreshMock: function (strategy,filename,callback) {
   	      var success = typeof callback !== 'function' ? null : function(data) {
              callback(data);
          };
          var callbackId = window.plus.bridge.callbackId(success);
   	   	  var args = [strategy,filename,callbackId];
   	   	  window.plus.bridge.exec(PLUGIN_NAME, "refreshMock",args);
   	   }
   };
   //输出插件
   window.PluginUtil.register("muna", PLUGIN_NAME, MUMockPlugin);

})();
