if (!window.PluginUtil) {
    var PluginUtil = {
        register: function (namespace, pluginName, rawPlugin) {
            for (var methodName in rawPlugin) {
                if (!rawPlugin.hasOwnProperty(methodName) || (typeof rawPlugin[methodName] != 'function'))
                    continue;
                window[namespace] = window[namespace] || {};
                if (!window[namespace][pluginName]) {
                    window[namespace][pluginName] = {};
                }

                var pluginProxy = window[namespace][pluginName];
                pluginProxy[methodName] = (function (methodName) {
                    return function () {
                        var args = arguments;
                        if (window.plus && window.plus.isReady) {
                            rawPlugin[methodName].apply(window, args);
                        } else {
                            document.addEventListener("plusready", function () {
                                rawPlugin[methodName].apply(window, args);
                            }, true);
                        }
                    }
                })(methodName);
            }
        }
    };
}


(function () {
    //插件名称
    var PLUGIN_NAME = "NotificationPlugin";

    //定义JS插件
    var NotificationPlugin = {
        createOneNetAccountResultAction : function (result) {
                        var args = [result];
                        return window.plus.bridge.exec(PLUGIN_NAME, "createOneNetAccountResultAction", args);
                   },
        postEvent : function (event,params) {
                    var args = [event,params];
                    return window.plus.bridge.exec(PLUGIN_NAME, "postEvent",args);
               },
        eventNotification : function (event) {
            var args = [event];
            return window.plus.bridge.exec(PLUGIN_NAME, "eventNotification", args);
        },
        registerNativeNoticeEvent : function (event, callback) {
            var success = typeof callback !== 'function' ? null : function(data) {
                                    callback(data);
            };
            var callbackId = window.plus.bridge.callbackId(success);
            var args = [event, callbackId];
            return window.plus.bridge.exec(PLUGIN_NAME, "registerNativeNoticeEvent", args);
        }
    };
    //输出插件
    window.PluginUtil.register("muapp", PLUGIN_NAME, NotificationPlugin);

})();
