if (!window.PluginUtil) {
    var PluginUtil = {
        register: function(namespace, pluginName, rawPlugin) {
            for (var methodName in rawPlugin) {
                if (!rawPlugin.hasOwnProperty(methodName) || (typeof rawPlugin[methodName] != 'function'))
                    continue;

                window[namespace] = window[namespace] || {};
                if (!window[namespace][pluginName]) {
                    window[namespace][pluginName] = {};
                }

                var pluginProxy = window[namespace][pluginName];
                pluginProxy[methodName] = (function(methodName) {
                    return function() {
                        if (window.plus && window.plus.isReady) {
                            rawPlugin[methodName].apply(window, arguments);
                        } else {
                            document.addEventListener("plusready",  function() {
                                rawPlugin[methodName].apply(window, arguments);
                            }, true);
                        }
                    }
                })(methodName);
            }
        }
    };
}

(function() {
    //插件名称
    var PLUGIN_NAME = "ThirdPartyLoginPlugin";

    //定义JS插件
    var ThirdPartyLoginPlugin = {
        /**
        var message = {url: url, successListener: function(data) {

        }, failListener: function(data) {

        }}
        **/
        wechatLogin: function (message) {

             var success = function(data) {
                if(typeof message.successListener == 'function') {
                    message.successListener(data);
                }
             };

             var fail = function(data) {
                if(typeof message.failListener == 'function') {
                    message.failListener(data);
                }
             };
             var callbackId = window.plus.bridge.callbackId(success, fail);
             var args = [callbackId, message];
             window.plus.bridge.exec(PLUGIN_NAME, "wechatLogin", args);
        },
    };
    //输出插件
    window.PluginUtil.register("muna", PLUGIN_NAME, ThirdPartyLoginPlugin);

})();